#include "stdafx.h"
#include "ServerCommunicator.h"

CServerCommunicator::CServerCommunicator(CWinThread* pDefThread, CCoordinator* pCoordinator, CSystemClock *pSystemClock) : 
    CEventRecipient(pDefThread, pCoordinator), m_pSystemClock(pSystemClock)
{
    RegisterEvent(ET__PROCESS_PERCEPTION);
    RegisterEvent(ET__ACT);
}

CServerCommunicator::~CServerCommunicator()
{
    UnregisterEvent(ET__PROCESS_PERCEPTION);
    UnregisterEvent(ET__ACT);
}

void CServerCommunicator::OnEvent(CBasicEvent *pEvent)
{
	TRACE("OnEvent: %d\n", pEvent->m_eEventType);

	switch (pEvent->m_eEventType)
	{
	case ET__PROCESS_PERCEPTION:
        CPerception *pPerception;
        CPerceptionSeq *pPerceptionSeq;

        // FIXME: potrebujem urobit copy-release
        pPerception = new CPerception(*((CProcessPerceptionEvent*) pEvent)->m_pPerception);

        pPerceptionSeq = new CPerceptionSeq;
        pPerceptionSeq->AddPerception(pPerception);
        
        PostEvent(new CDeliberateEvent(pPerceptionSeq));
		break;

	case ET__ACT:
        CGameCommand *pSendCommand;
        CGameCommandSeq *pSendCommandSeq;

        pSendCommandSeq = ((CActEvent*) pEvent)->m_pGameCommandSeq;
        while (pSendCommandSeq->GetGameCommand(&pSendCommand))
		{
            //nLastSendTime = nGameCycles;
            PostEvent(new CSendCommandEvent(pSendCommand));
        }
		break;
	}

	pEvent->Release();
}
